library ieee;
use ieee.std_logic_1164.all;

entity part5b is
	port(
		SW: in std_logic_vector(9 downto 0);
		HEX0, HEX1, HEX2: out std_logic_vector(0 to 6));
end part5b;

architecture arch_part5b of part5b is

component mux_2bit_3to1
	port(
		S, U, V, W: in std_logic_vector(1 downto 0);
		M: out std_logic_vector(1 downto 0));
end component;

component char_7seg
	port(
		C: in std_logic_vector(1 downto 0);
		Display: out std_logic_vector(0 to 6));
end component;

signal M0, M1, M2: std_logic_vector(1 downto 0);
signal CH1, CH2, CH3, SEL: std_logic_vector(1 downto 0);

begin
	
	mux2: mux_2bit_3to1 PORT MAP (SEL,CH1,CH2,CH3,M2);
	h2: char_7seg PORT MAP (M2,HEX2);
	
	mux1: mux_2bit_3to1 PORT MAP (SEL,CH2,CH3,CH1,M1);
	h1: char_7seg PORT MAP (M1,HEX1);
	
	mux0: mux_2bit_3to1 PORT MAP (SEL,CH3,CH1,CH2,M0);
	h0: char_7seg PORT MAP (M0,HEX0);
	
	CH1 <= SW(5 downto 4);
	CH2 <= SW(3 downto 2);
	CH3 <= SW(1 downto 0);
	SEL <= SW(9 downto 8);
	
end arch_part5b;

----------------------------------------
library ieee;
use ieee.std_logic_1164.all;

entity mux_2bit_3to1 is
	port(
		S, U, V, W: in std_logic_vector(1 downto 0);
		M: out std_logic_vector(1 downto 0));
end mux_2bit_3to1;

architecture arch_mux_2bit_3to1 of mux_2bit_3to1 is
signal m0, m1: std_logic;
begin
	
	M(0) <= (not (S(1)) and m0) or (S(1) and W(0));
	m0 <= (not (S(0)) and U(0)) or (S(0) and V(0));

	M(1) <= (not (S(1)) and m1) or (S(1) and W(1));
	m1 <= (not (S(0)) and U(1)) or (S(0) and V(1));
		
end arch_mux_2bit_3to1;

----------------------------------------
library ieee;
use ieee.std_logic_1164.all;

entity char_7seg is
	port(
		C: in std_logic_vector(1 downto 0);
		Display: out std_logic_vector(0 to 6));
end char_7seg;

architecture arch_char_7seg of char_7seg is
begin
	
	with C select Display <=
		"1000010" when "00",
		"0110000" when "01",
		"0000001" when "10",
		"1111111" when others;

end arch_char_7seg;