library ieee;
use ieee.std_logic_1164.all;

entity part6 is
	port(
		SW: in std_logic_vector(9 downto 0);
		HEX0, HEX1, HEX2, HEX3: out std_logic_vector(0 to 6));
end part6;

architecture arch_part6 of part6 is

component mux_2bit_4to1
	port(
		S, U, V, W, X: std_logic_vector(1 downto 0);
		M: out std_logic_vector(1 downto 0));
end component;

component char_7seg
	port(
		C: in std_logic_vector(1 downto 0);
		Display: out std_logic_vector(0 to 6));
end component;

signal M0, M1, M2, M3: std_logic_vector(1 downto 0);
signal CH1, CH2, CH3, SEL: std_logic_vector(1 downto 0);

begin
	
	mux3: mux_2bit_4to1 PORT MAP (SEL,"11",CH1,CH2,CH3,M3);
	h3: char_7seg PORT MAP (M3,HEX3);
	
	mux2: mux_2bit_4to1 PORT MAP (SEL,CH1,CH2,CH3,"11",M2);
	h2: char_7seg PORT MAP (M2,HEX2);
	
	mux1: mux_2bit_4to1 PORT MAP (SEL,CH2,CH3,"11",CH1,M1);
	h1: char_7seg PORT MAP (M1,HEX1);
	
	mux0: mux_2bit_4to1 PORT MAP (SEL,CH3,"11",CH1,CH2,M0);
	h0: char_7seg PORT MAP (M0,HEX0);

	CH1 <= SW(5 downto 4);
	CH2 <= SW(3 downto 2);
	CH3 <= SW(1 downto 0);
	SEL <= SW(9 downto 8);
	
end arch_part6;

----------------------------------------
library ieee;
use ieee.std_logic_1164.all;

entity mux_2bit_4to1 is
	port(
		S, U, V, W, X: std_logic_vector(1 downto 0);
		M: out std_logic_vector(1 downto 0));
end mux_2bit_4to1;

architecture arch_mux_2bit_4to1 of mux_2bit_4to1 is
begin
	
	with S select M <=
		U when "00",
		V when "01",
		W when "10",
		X when others;
		
end arch_mux_2bit_4to1;

----------------------------------------
library ieee;
use ieee.std_logic_1164.all;

entity char_7seg is
	port(
		C: in std_logic_vector(1 downto 0);
		Display: out std_logic_vector(0 to 6));
end char_7seg;

architecture arch_char_7seg of char_7seg is
begin
	
	with C select Display <=
		"1000010" when "00",
		"0110000" when "01",
		"0000001" when "10",
		"1111111" when others;

end arch_char_7seg;