library ieee;
use ieee.std_logic_1164.all;

entity part1a is
	port(
		SW: in std_logic_vector(9 downto 0);
		KEY: in std_logic_vector(2 downto 0);
		LEDG: out std_logic_vector(9 downto 0));
end part1a;

architecture arch_part1a of part1a is
signal reset,clk,w,z: std_logic;
signal STATE: std_logic_vector(8 downto 0);
constant A: std_logic_vector(8 downto 0):="000000001";
constant B: std_logic_vector(8 downto 0):="000000010";
constant C: std_logic_vector(8 downto 0):="000000100";
constant D: std_logic_vector(8 downto 0):="000001000";
constant E: std_logic_vector(8 downto 0):="000010000";
constant F: std_logic_vector(8 downto 0):="000100000";
constant G: std_logic_vector(8 downto 0):="001000000";
constant H: std_logic_vector(8 downto 0):="010000000";
constant I: std_logic_vector(8 downto 0):="100000000";

begin
	
	fsm: process (clk)
	begin
		if clk'event and clk = '1' then
			if reset = '0' then
				STATE <= A;
			else
				case STATE is
					when A =>
						if w = '0' then
							STATE <= B;
						else
							STATE <= F;
						end if;
					when B =>
						if w = '0' then
							STATE <= C;
						else
							STATE <= F;
						end if;
					when C =>
						if w = '0' then
							STATE <= D;
						else
							STATE <= F;
						end if;
					when D =>
						if w = '0' then
							STATE <= E;
						else
							STATE <= F;
						end if;
					when E =>
						if w = '0' then
							STATE <= E;
						else
							STATE <= F;
						end if;
					when F =>
						if w = '0' then
							STATE <= B;
						else
							STATE <= G;
						end if;
					when G =>
						if w = '0' then
							STATE <= B;
						else
							STATE <= H;
						end if;
					when H =>
						if w = '0' then
							STATE <= B;
						else
							STATE <= I;
						end if;
					when I =>
						if w = '0' then
							STATE <= B;
						else
							STATE <= I;
						end if;
					when others =>
						STATE <= A;
				end case;
			end if;
		end if;
	end process fsm;
	
	z <= '1' when STATE = E else '1' when STATE = I else '0';
		
	reset <= SW(0);
	clk <= KEY(0);
	w <= SW(1);
	LEDG(9) <= z;
	LEDG(8 downto 0) <= STATE;
	
end arch_part1a;