library ieee;
use ieee.std_logic_1164.all;

entity part2 is
	port(
		SW: in std_logic_vector(9 downto 0);
		KEY: in std_logic_vector(2 downto 0);
		LEDG: out std_logic_vector(9 downto 0));
end part2;

architecture arch_part2 of part2 is
signal reset,clk,w,z: std_logic;
signal STATE_OUT: std_logic_vector(3 downto 0);
type states is (A, B, C, D, E, F, G, H, I);
attribute syn_encoding: string;
attribute syn_encoding of states: type is "0000 0001 0010 0011 0100 0101 0110 0111 1000";
signal STATE, FUT_STATE: states;

begin
	
	registers: process (clk)
	begin
		if clk'event and clk = '1' then
			if reset = '0' then
				STATE <= A;
			else
				STATE <= FUT_STATE;
			end if;
		end if;
	end process registers;
	
	logic: process (w, STATE)
	begin	
		case STATE is
			when A =>
				if w = '0' then
					FUT_STATE <= B;
				else
					FUT_STATE <= F;
				end if;
			when B =>
				if w = '0' then
					FUT_STATE <= C;
				else
					FUT_STATE <= F;
				end if;
			when C =>
				if w = '0' then
					FUT_STATE <= D;
				else
					FUT_STATE <= F;
				end if;
			when D =>
				if w = '0' then
					FUT_STATE <= E;
				else
					FUT_STATE <= F;
				end if;
			when E =>
				if w = '0' then
					FUT_STATE <= E;
				else
					FUT_STATE <= F;
				end if;
			when F =>
				if w = '0' then
					FUT_STATE <= B;
				else
					FUT_STATE <= G;
				end if;
			when G =>
				if w = '0' then
					FUT_STATE <= B;
				else
					FUT_STATE <= H;
				end if;
			when H =>
				if w = '0' then
					FUT_STATE <= B;
				else
					FUT_STATE <= I;
				end if;
			when I =>
				if w = '0' then
					FUT_STATE <= B;
				else
					FUT_STATE <= I;
				end if;
			when others =>
				FUT_STATE <= A;
		end case;

	end process logic;
		
	z <= '1' when STATE = E else '1' when STATE = I else '0';
	with STATE select STATE_OUT <= 
		"0000" when A,
		"0001" when B,
		"0010" when C,
		"0011" when D,
		"0100" when E,
		"0101" when F,
		"0110" when G,
		"0111" when H,
		"1000" when I,	
		"0000" when others;
	
	reset <= SW(0);
	clk <= KEY(0);
	w <= SW(1);
	LEDG(9) <= z;
	LEDG(3 downto 0) <= STATE_OUT;
	
end arch_part2;