library ieee;
use ieee.std_logic_1164.all;

entity part3 is
	port(
		SW: in std_logic_vector(9 downto 0);
		KEY: in std_logic_vector(2 downto 0);
		LEDG: out std_logic_vector(9 downto 0));
end part3;

architecture arch_part3 of part3 is

component shreg
	port(
		clk, synres, synset, serin: in std_logic;
		PAROUT: buffer std_logic_vector(3 downto 0));
end component;

signal reset,clk,w,z: std_logic;
signal REGOUT0, REGOUT1: std_logic_vector (3 downto 0);

begin

	reg0: shreg port map(clk,'1',reset,w,REGOUT0);
	reg1: shreg port map(clk,reset,'1',w,REGOUT1);
	z <= '1' when REGOUT0="0000" else '1' when REGOUT1="1111" else '0';
		
	reset <= SW(0);
	clk <= KEY(0);
	w <= SW(1);
	LEDG(9) <= z;
	LEDG(3 downto 0) <= REGOUT0;
	LEDG(7 downto 4) <= REGOUT1;
	
end arch_part3;

----------------------------------------
library ieee;
use ieee.std_logic_1164.all;

entity shreg is
	port(
		clk, synres, synset, serin: in std_logic;
		PAROUT: buffer std_logic_vector(3 downto 0));
end shreg;

architecture arch_shreg of shreg is

begin
	
	reg: process (clk)
	begin
		if clk'event and clk = '1' then
			if synres = '0' then
				PAROUT <= (others =>'0');
			elsif synset = '0' then
				PAROUT <= (others =>'1');
			else
				PAROUT <= serin & PAROUT(3 downto 1);
			end if;
		end if;
	end process reg;
	
end arch_shreg;